import 'dart:async';

import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'package:flutter/scheduler.dart';
import 'package:flutter/widgets.dart';
import 'widget_tree/wireframe.dart';

class SmartlookHelperController {
  SmartlookHelperController._privateConstructor();

  static final SmartlookHelperController instance =
      SmartlookHelperController._privateConstructor();

  SchedulerBinding schedulerBinding = SchedulerBinding.instance!;

  final GlobalKey _containerKey = GlobalKey();

  int skipped = 0;

  int? screenHeight;
  int? screenWidth;

  Future<WireframeData> buildWireframeTree() async {
    final c = new Completer<WireframeData>();

    BuildContext ctx = _containerKey.currentContext!;

    WireframeData wireframeData = WireframeData();
    await wireframeData.fillFromElement(ctx);
    c.complete(wireframeData);

    return c.future;
  }
}

class SmartlookHelperWidget extends StatelessWidget {
  SmartlookHelperWidget({
    Key? key,
    required this.child,
  }) : super(key: key);

  final Widget child;

  @override
  Widget build(BuildContext context) {
    return RepaintBoundary(
        key: SmartlookHelperController.instance._containerKey,
        child: Container(
          child: child,
        ));
  }
}
